searchData={"items":[{"type":"module","title":"LoggerFileBackend","doc":"`LoggerFileBackend` is a custom backend for the elixir `:logger` application.","ref":"LoggerFileBackend.html"},{"type":"function","title":"LoggerFileBackend.handle_call/2","doc":"","ref":"LoggerFileBackend.html#handle_call/2"},{"type":"function","title":"LoggerFileBackend.handle_event/2","doc":"","ref":"LoggerFileBackend.html#handle_event/2"},{"type":"function","title":"LoggerFileBackend.handle_info/2","doc":"","ref":"LoggerFileBackend.html#handle_info/2"},{"type":"function","title":"LoggerFileBackend.init/1","doc":"","ref":"LoggerFileBackend.html#init/1"},{"type":"function","title":"LoggerFileBackend.prune/1","doc":"","ref":"LoggerFileBackend.html#prune/1"},{"type":"type","title":"LoggerFileBackend.file/0","doc":"","ref":"LoggerFileBackend.html#t:file/0"},{"type":"type","title":"LoggerFileBackend.format/0","doc":"","ref":"LoggerFileBackend.html#t:format/0"},{"type":"type","title":"LoggerFileBackend.inode/0","doc":"","ref":"LoggerFileBackend.html#t:inode/0"},{"type":"type","title":"LoggerFileBackend.level/0","doc":"","ref":"LoggerFileBackend.html#t:level/0"},{"type":"type","title":"LoggerFileBackend.metadata/0","doc":"","ref":"LoggerFileBackend.html#t:metadata/0"},{"type":"type","title":"LoggerFileBackend.path/0","doc":"","ref":"LoggerFileBackend.html#t:path/0"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\nAll notable changes to this project will be documented in this file.\n\nThe format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),\nand this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).\n\n## [Unreleased]","ref":"changelog.html"},{"type":"extras","title":"v0.0.14 - Changelog","doc":"- fix warnings about the use of deprecated :warn\n- Bumps versions of `credo` and `ex_doc` to latest","ref":"changelog.html#v0-0-14"},{"type":"extras","title":"v0.0.13 - Changelog","doc":"- Docs cleanup\n- Release file handle\n- Bumps versions of `credo` and `ex_doc` to latest","ref":"changelog.html#v0-0-13"},{"type":"extras","title":"v0.0.12 - 2021-07-19 - Changelog","doc":"- Bumps dependency versions\n- Combing through documentation","ref":"changelog.html#v0-0-12-2021-07-19"},{"type":"extras","title":"v0.0.11 - 2019-08-06 - Changelog","doc":"","ref":"changelog.html#v0-0-11-2019-08-06"},{"type":"extras","title":"Enhancements - Changelog","doc":"- Add simple strategy to rotate log files ([3a4d7f](https://github.com/mstratman/logger_file_backend/commit/3a4d7ffea4fd1ea4f4ba2629051efc259dd668ec))\n- Allow :all in :metadata option ([#54](https://github.com/onkel-dirtus/logger_file_backend/pull/54))","ref":"changelog.html#enhancements"},{"type":"extras","title":"Fixes - Changelog","doc":"- Documentation fix ([#39](https://github.com/onkel-dirtus/logger_file_backend/pull/39))\n- Eliminate warnings ([#30](https://github.com/onkel-dirtus/logger_file_backend/pull/30), [361c7d](https://github.com/mstratman/logger_file_backend/commit/361c7d81cb408a8aee824d080e16fd26f1920621), [1f0390](https://github.com/mstratman/logger_file_backend/commit/1f0390b29fe90516bd4b70d82250de065900fd41), [#43](https://github.com/onkel-dirtus/logger_file_backend/pull/43))","ref":"changelog.html#fixes"},{"type":"extras","title":"Changes - Changelog","doc":"- Update dependencies ([#30](https://github.com/onkel-dirtus/logger_file_backend/pull/30))","ref":"changelog.html#changes"},{"type":"extras","title":"License","doc":"# The MIT License (MIT)\n\nCopyright (c) 2014 Kurt Williams\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html"},{"type":"extras","title":"Overview","doc":"# LoggerFileBackend\n\n[![Module Version](https://img.shields.io/hexpm/v/logger_file_backend.svg)](https://hex.pm/packages/logger_file_backend)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/logger_file_backend/)\n[![Total Download](https://img.shields.io/hexpm/dt/logger_file_backend.svg)](https://hex.pm/packages/logger_file_backend)\n[![License](https://img.shields.io/hexpm/l/logger_file_backend.svg)](https://github.com/onkel-dirtus/logger_file_backend/blob/master/LICENSE.md)\n[![Last Updated](https://img.shields.io/github/last-commit/onkel-dirtus/logger_file_backend.svg)](https://github.com/onkel-dirtus/logger_file_backend/commits/master)\n\nA simple Elixir `Logger` backend which writes logs to a file. It does not handle log rotation, but it does tolerate log file renames, so it can be used in conjunction with external log rotation.\n\n**Note** The renaming of log files does not work on Windows, because `File.Stat.inode` is used to determine whether the log file has been (re)moved and, on non-Unix, `File.Stat.inode` is always 0.\n\n**Note** If you are running this with the Phoenix framework, please review the Phoenix specific instructions later on in this file.","ref":"readme.html"},{"type":"extras","title":"Configuration - Overview","doc":"`LoggerFileBackend` is a custom backend for the elixir `:logger` application. As\nsuch, it relies on the `:logger` application to start the relevant processes.\nHowever, unlike the default `:console` backend, we may want to configure\nmultiple log files, each with different log levels, formats, etc. Also, we want\n`:logger` to be responsible for starting and stopping each of our logging\nprocesses for us. Because of these considerations, there must be one `:logger`\nbackend configured for each log file we need. Each backend has a name like\n`{LoggerFileBackend, id}`, where `id` is any elixir term (usually an atom).\n\nFor example, let's say we want to log error messages to\n`\"/var/log/my_app/error.log\"`. To do that, we will need to configure a backend.\nLet's call it `{LoggerFileBackend, :error_log}`.\n\nOur `config.exs` would have an entry similar to this:\n\n```elixir\n# tell logger to load a LoggerFileBackend processes\nconfig :logger,\n  backends: [{LoggerFileBackend, :error_log}]\n```\n\nWith this configuration, the `:logger` application will start one `LoggerFileBackend`\nnamed `{LoggerFileBackend, :error_log}`. We still need to set the correct file\npath and log levels for the backend, though. To do that, we add another config\nstanza. Together with the stanza above, we'll have something like this:\n\n```elixir\n# tell logger to load a LoggerFileBackend processes\nconfig :logger,\n  backends: [{LoggerFileBackend, :error_log}]\n\n# configuration for the {LoggerFileBackend, :error_log} backend\nconfig :logger, :error_log,\n  path: \"/var/log/my_app/error.log\",\n  level: :error\n```\n\nCheck out the examples below for runtime configuration and configuration for\nmultiple log files.\n\n`LoggerFileBackend` supports the following configuration values:\n\n* `path` - the path to the log file\n* `level` - the logging level for the backend\n* `format` - the logging format for the backend\n* `metadata` - the metadata to include\n* `metadata_filter` - metadata terms which must be present in order to log\n* metadata_reject - metadata terms which must be present in order to do not log","ref":"readme.html#configuration"},{"type":"extras","title":"Examples - Overview","doc":"#### Runtime configuration\n\n```elixir\nLogger.add_backend {LoggerFileBackend, :debug}\nLogger.configure_backend {LoggerFileBackend, :debug},\n  path: \"/path/to/debug.log\",\n  format: ...,\n  metadata: ...,\n  metadata_filter: ...\n```\n\n#### Application config for multiple log files\n\n```elixir\nconfig :logger,\n  backends: [{LoggerFileBackend, :info},\n             {LoggerFileBackend, :error}]\n\nconfig :logger, :info,\n  path: \"/path/to/info.log\",\n  level: :info\n\nconfig :logger, :error,\n  path: \"/path/to/error.log\",\n  level: :error\n```\n\n#### Filtering specific metadata terms\n\nThis example only logs `:info` statements originating from the `:ui` OTP app; the `:application` metadata key is auto-populated by `Logger`.\n\n```elixir\nconfig :logger,\n  backends: [{LoggerFileBackend, :ui}]\n\nconfig :logger, :ui,\n  path: \"/path/to/ui.log\",\n  level: :info,\n  metadata_filter: [application: :ui]\n```\n\nThis example only writes log statements with a custom metadata key to the file.\n\n```elixir\n# in a config file:\nconfig :logger,\n  backends: [{LoggerFileBackend, :device_1}]\n\nconfig :logger, :device_1,\n  path: \"/path/to/device_1.log\",\n  level: :debug,\n  metadata_filter: [device: 1]\n\n# Usage:\n# anywhere in the code:\nLogger.info(\"statement\", device: 1)\n\n# or, for a single process, e.g., a GenServer:\n# in init/1:\nLogger.metadata(device: 1)\n# ^ sets device: 1 for all subsequent log statements from this process.\n\n# Later, in other code (handle_cast/2, etc.)\nLogger.info(\"statement\") # <= already tagged with the device_1 metadata\n```","ref":"readme.html#examples"},{"type":"extras","title":"Additional Phoenix Configurations - Overview","doc":"Phoenix makes use of its own `mix.exs` file to track dependencies and additional applications. Add the following to your `mix.exs`:\n\n```elixir\ndef application do\n    [applications: [\n      ...,\n      :logger_file_backend,\n      ...\n      ]\n    ]\nend\n\ndefp deps do\n  [ ...\n    {:logger_file_backend, \"~> 0.0.10\"},\n  ]\nend\n```","ref":"readme.html#additional-phoenix-configurations"},{"type":"extras","title":"Copyright and License - Overview","doc":"Copyright (c) 2014 Kurt Williams\n\nThis library licensed under the [MIT license](./LICENSE.md).","ref":"readme.html#copyright-and-license"},{"type":"extras","title":"Image Attribution - Overview","doc":"\"log\" by Matthew Weatherall from [the Noun Project](https://thenounproject.com/).","ref":"readme.html#image-attribution"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,50,46,49]}}